﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace ModbusMon
{
    public partial class SetComForm : Form
    {
        public SetComForm()
        {
            InitializeComponent();
            portName = "";
            bitrate = 9600;
        }

        private string portName;

        //private uint port;
        private int bitrate;



        //private const int MinPort = 1;
        private const int MaxPort = 24;

        //public uint Port {
        //    get {
        //        return port;
        //    }

        //    set {
        //        port = value;
        //    }
        //}

        public int Bitrate {
            get {
                return bitrate;
            }

            set {
                bitrate = value;
            }
        }

        public string PortName {
            get {
                return portName;
            }

            set {
                portName = value;
            }
        }

        private void SetComForm_Load(object sender, EventArgs e)
        {
            //string[] stdBitRate = { "1200", "9600", "19200", "38400", "57600", "115200" };
            int[] stdBitRateArray = { 1200, 9600, 19200, 38400, 57600, 115200 };


            //if (port < MinPort) port = MinPort;
            //else if (port > MaxPort) port = MaxPort;

            string str;
            //int i;
            //int selIndex=-1;
            //for ( i = 0; i <= MaxPort; i++)
            //{
            //    str = "COM" + (i+1).ToString("D");
            //    if (str == portName) selIndex = i;
            //    comboBoxComPort.Items.Add(str);
            //}
            //if (selIndex < 0) {
            //    comboBoxComPort.Items.Add(portName);
            //    selIndex = i;
            //}
            //comboBoxComPort.SelectedIndex = selIndex;


            int i;
            int selIndex = -1;

            string[] portNames = SerialPort.GetPortNames();

            int n = portNames.Length;

            for (i = 0; i < n; i++)
            {
                if (portNames[i] == portName)
                {
                    selIndex = i;
                }
                comboBoxComPort.Items.Add(portNames[i]);

                //str = "COM" + (i + 1).ToString("D");
                //if (str == comPortName) selIndex = i;
                //comboBoxCOMPORT.Items.Add(str);
            }
            if (selIndex < 0)
            {
                comboBoxComPort.Items.Add(portName);
                selIndex = i;
            }
            comboBoxComPort.SelectedIndex = selIndex;









            selIndex = -1;
            for (i = 0; i<stdBitRateArray.Length; i++)
            {
                if(stdBitRateArray[i] == bitrate)  selIndex = i;
                str = stdBitRateArray[i].ToString("D");
                comboBoxBitRate.Items.Add(str);
            }

            if (selIndex < 0)
            {
                str = bitrate.ToString("D");
                comboBoxBitRate.Items.Add(str);
                selIndex = i;
            }
            comboBoxBitRate.SelectedIndex = selIndex;
        }

        private void IDOK_Click(object sender, EventArgs e)
        {
            portName = comboBoxComPort.Text;
            bool r = Int32.TryParse(comboBoxBitRate.Text, out bitrate);
            if (!r || bitrate < 75) return;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }
    }
}
